clear
close all
clc

% read in data from raw Neurolucida hand-trace

%filename = 'AR-1-20-04-B.asc'
filename = 'hinesfork.asc'
%filename = 'testcox.asc'

% get data from raw trace
nc = neur_converterh(filename);

% simulation time
simd.dt = 0.01;   % ms
simd.T = 12;    % ms
simd.Is.start = 2;  % ms
simd.Is.end = 3.5;   % ms

% current pulse (at soma for now)
simd.Is.mag = 0.005;  % uA
%simd.Is.mag = 0;  % nA

% time vector
simd.t = 0:simd.dt:simd.T;

% reproduce morphology of neuron
%md = neur_loadmorph2(nc,.05,1)
md = neur_loadmorph_direct(nc,29,1);

% physiological parameters
p_const = neur_param_const(nc);
p_conds = neur_param_conds(nc,md);

% M K L (Mass and Stiffness matrices) for Passive Fiber
[M, K, L, b, md] = neur_assembleMKh(nc,md,p_const,p_conds);
%[CM,CK] = neur_assembleCa(nc,md,p_const,p_conds);

save ncmd nc md

% Hines solver

disp('M,K,L ready')
disp('Solving system...')

% solve for v
tic
out = neur_solverh_act(M,K,L,b,nc,md,p_const,p_conds,simd,filename);
toc

fprintf('\n')
save out out

neur_cellguih
