close all
clear
clc

syms x i h
syms phirm philp phir phil
syms dphirm dphilm dphirp dphilp
syms ai aim aip
syms hi him hip
syms mi mim mip
syms Gi Gim

phil = 1/h*(x-(i-1)*h);
phirm = -1/h*(x-((i-1)+1)*h);
phir = -1/h*(x-(i+1)*h); 
philp = 1/h*(x-((i+1)-1)*h);

dphil = 1/h;
dphirm = -1/h;
dphir = -1/h;
dphilp = 1/h;

Mcenbeg = simplify(sqrt(1 + (ai/h - aip/h)^2)*...
                   int(phir*phir*(aip*philp+ai*phir),i*h,(i+1)*h));
Mcenend = simplify(sqrt(1 + (ai/h - aim/h)^2)*...
                   int(phil*phil*(aim*phirm+ai*phil),(i-1)*h,i*h));
Kcenbeg = simplify(int(dphir*dphir*(aip*philp+ai*phir)^2,x,i*h,(i+1)*h));
Kcenend = simplify(int(dphil*dphil*(aim*phirm+ai*phil)^2,x,(i-1)*h,(i)*h));

Mcen = simplify(sqrt(1 + (ai/h - aim/h)^2)*...
                int(phil*phil*(aim*phirm+ai*phil),(i-1)*h,i*h)+...
                sqrt(1 + (ai/h - aip/h)^2)*...
                int(phir*phir*(aip*philp+ai*phir),i*h,(i+1)*h));
Kcen = simplify(int(dphil*dphil*(aim*phirm+ai*phil)^2,x,(i-1)*h,i*h)+...
                int(dphir*dphir*(aip*philp+ai*phir)^2,x,i*h,(i+1)*h));

Moff = simplify(sqrt(1 + (ai/h - aip/h)^2)*...
                 int(phir*philp*(aip*philp+ai*phir),i*h,(i+1)*h));
Koff = simplify(int(dphir*dphilp*(aip*philp+ai*phir)^2,x,i*h,(i+1)*h));

PasRHS = simplify(sqrt(1 + (ai/h - aim/h)^2)*...
                 int(phil*(aim*phirm+ai*phil),(i-1)*h,i*h)+...
                 sqrt(1 + (ai/h - aip/h)^2)*...
                 int(phir*(aip*philp+ai*phir),i*h,(i+1)*h));

% IH

IHcenbeg = simplify(sqrt(1 + (ai/h - aip/h)^2)*...
                   int(phir*phir*(aip*philp+ai*phir)*(hip^2*philp+hi^2*phir),i*h,(i+1)*h));
IHcenend = simplify(sqrt(1 + (ai/h - aim/h)^2)*...
                   int(phil*phil*(aim*phirm+ai*phil)*(him^2*phirm+hi^2*phil),(i-1)*h,i*h));
IHcen = simplify(sqrt(1 + (ai/h - aim/h)^2)*...
                int(phil*phil*(aim*phirm+ai*phil)*(him^2*phirm+hi^2*phil),(i-1)*h,i*h)+...
                sqrt(1 + (ai/h - aip/h)^2)*...
                int(phir*phir*(aip*philp+ai*phir)*(hip^2*philp+hi^2*phir),i*h,(i+1)*h));
IHoff = simplify(sqrt(1 + (ai/h - aip/h)^2)*...
                 int(phir*philp*(aip*philp+ai*phir)*(hip^2*philp+hi^2*phir),i*h,(i+1)*h));
IHRHS = simplify(sqrt(1 + (ai/h - aim/h)^2)*...
                int(phil*(aim*phirm+ai*phil)*(him^2*phirm+hi^2*phil),(i-1)*h,i*h)+...
                sqrt(1 + (ai/h - aip/h)^2)*...
                int(phir*(aip*philp+ai*phir)*(hip^2*philp+hi^2*phir),i*h,(i+1)*h));             
             
% IK

IKcenbeg = simplify(sqrt(1 + (ai/h - aip/h)^2)*...
                   int(phir*phir*(aip*philp+ai*phir)*(hip^4*philp+hi^4*phir),i*h,(i+1)*h));
IKcenend = simplify(sqrt(1 + (ai/h - aim/h)^2)*...
                   int(phil*phil*(aim*phirm+ai*phil)*(him^4*phirm+hi^4*phil),(i-1)*h,i*h));
IKcen = simplify(sqrt(1 + (ai/h - aim/h)^2)*...
                int(phil*phil*(aim*phirm+ai*phil)*(him^4*phirm+hi^4*phil),(i-1)*h,i*h)+...
                sqrt(1 + (ai/h - aip/h)^2)*...
                int(phir*phir*(aip*philp+ai*phir)*(hip^4*philp+hi^4*phir),i*h,(i+1)*h));
IKoff = simplify(sqrt(1 + (ai/h - aip/h)^2)*...
                 int(phir*philp*(aip*philp+ai*phir)*(hip^4*philp+hi^4*phir),i*h,(i+1)*h));
IKRHS = simplify(sqrt(1 + (ai/h - aim/h)^2)*...
                int(phil*(aim*phirm+ai*phil)*(him^4*phirm+hi^4*phil),(i-1)*h,i*h)+...
                sqrt(1 + (ai/h - aip/h)^2)*...
                int(phir*(aip*philp+ai*phir)*(hip^4*philp+hi^4*phir),i*h,(i+1)*h));

% INa            
            
INacenbeg = simplify(sqrt(1 + (ai/h - aip/h)^2)*...
                   int(phir*phir*(aip*philp+ai*phir)*...
                   (mip^3*philp+mi^3*phir)*...           %m
                   (hip*philp+hi*phir),i*h,(i+1)*h));    %h
INacenend = simplify(sqrt(1 + (ai/h - aim/h)^2)*...
                   int(phil*phil*(aim*phirm+ai*phil)*...
                   (mim^3*phirm+mi^3*phil)*...
                   (him*phirm+hi*phil),(i-1)*h,i*h));
INacen = simplify(sqrt(1 + (ai/h - aim/h)^2)*...
                int(phil*phil*(aim*phirm+ai*phil)*...
                (mim^3*phirm+mi^3*phil)*...
                (him*phirm+hi*phil),(i-1)*h,i*h)+...
                sqrt(1 + (ai/h - aip/h)^2)*...
                int(phir*phir*(aip*philp+ai*phir)*...
                (mip^3*philp+mi^3*phir)*...
                (hip*philp+hi*phir),i*h,(i+1)*h));
INaoff = simplify(sqrt(1 + (ai/h - aip/h)^2)*...
                 int(phir*philp*(aip*philp+ai*phir)*...
                 (mip^3*philp+mi^3*phir)*...
                 (hip*philp+hi*phir),i*h,(i+1)*h));
INaRHS = simplify(sqrt(1 + (ai/h - aim/h)^2)*...
                int(phil*(aim*phirm+ai*phil)*...
                (mim^3*phirm+mi^3*phil)*...
                (him*phirm+hi*phil),(i-1)*h,i*h)+...
                sqrt(1 + (ai/h - aip/h)^2)*...
                int(phir*(aip*philp+ai*phir)*...
                (mip^3*philp+mi^3*phir)*...
                (hip*philp+hi*phir),i*h,(i+1)*h));

            
disp('M main diagonal')
pretty(Mcen)
disp('K main diagonal')
pretty(Kcen)
disp('M main diagonal first')
pretty(Mcenbeg)
disp('M main diagonal last')
pretty(Mcenend)
disp('K main diagonal first')
pretty(Kcenbeg)
disp('K main diagonal last')
pretty(Kcenend)
disp('M off diagonal')
pretty(Moff)
disp('K off diagonal')
pretty(Koff)
disp('Pas RHS')
pretty(PasRHS)
disp('IH main diagonal')
pretty(factor(IHcen))
disp('IH main diagonal first')
pretty(IHcenbeg)
disp('IH main diagonal last')
pretty(IHcenend)
disp('IH off diagonal')
pretty(IHoff)
disp('IH RHS')
pretty(factor(IHRHS))
disp('INa main diagonal')
pretty(factor(INacen))
disp('INa main diagonal first')
pretty(INacenbeg)
disp('INa main diagonal last')
pretty(INacenend)
disp('INa off diagonal')
pretty(INaoff)
disp('INa RHS')
pretty(factor(INaRHS))