% Nan Xiao

% 6/29/05

% assemble M K L matrices in the 'Hines' method

function [IH_lhs,IH_rhs,IK_lhs,IK_rhs,INa_lhs,INa_rhs,IL_lhs,IL_rhs,...
          IA_lhs,IA_rhs] = ...
          neur_assemble2(nc,md,p_const,p_conds,gate) 
% function [IH_lhs,IH_rhs,IK_lhs,IK_rhs,INa_lhs,INa_rhs,IL_lhs,IL_rhs] = ...
%          neur_assemble2(nc,md,p_const,p_conds,gate) 


% set up up the data

IH_lhscen = cell(md.count.N,1);
IH_rhscen = cell(md.count.N,1);
IH_lhsoff = cell(md.count.N,1);

INa_lhscen = cell(md.count.N,1);
INa_rhscen = cell(md.count.N,1);
INa_lhsoff = cell(md.count.N,1);

IK_lhscen = cell(md.count.N,1);
IK_rhscen = cell(md.count.N,1);
IK_lhsoff = cell(md.count.N,1);

IA_lhscen = cell(md.count.N,1);
IA_rhscen = cell(md.count.N,1);
IA_lhsoff = cell(md.count.N,1);

IL_lhscen = cell(md.count.N,1);
IL_rhscen = cell(md.count.N,1);
IL_lhsoff = cell(md.count.N,1);

for jj = 1:md.count.N
    
    %md.interp.radii{jj} = md.interp.radii{jj}*1e-4;
    
    h = md.grid.hstep(jj);
    
%     ai  = md.interp.radii{jj};
%     aim = [0 ai(1:end-1)];
%     aip = [ai(2:end) 0];
    
    temp1 = sqrt(h^2+([0 md.interp.radii{jj}(1:end-1)]-md.interp.radii{jj}).^2);
    temp2 = sqrt(h^2+([md.interp.radii{jj}(2:end) 0]-md.interp.radii{jj}).^2);
    temp3 = (12*md.interp.radii{jj}+3*[0 md.interp.radii{jj}(1:end-1)]);
    temp4 = (3*md.interp.radii{jj}+2*[0 md.interp.radii{jj}(1:end-1)]);
    temp5 = (12*md.interp.radii{jj}+3*[md.interp.radii{jj}(2:end) 0]);
    temp6 = (3*md.interp.radii{jj}+2*[md.interp.radii{jj}(2:end) 0]);
    
    ui = gate.IH{jj}; 
    uim = [0 ui(1:end-1)];
    uip = [ui(2:end) 0];
    
%     hi = gate.INah{jj}; 
%     him = [0 hi(1:end-1)];
%     hip = [hi(2:end) 0];
%     
%     mi = gate.INam{jj}; 
%     mim = [0 mi(1:end-1)];
%     mip = [mi(2:end) 0];

    mhi = gate.INam{jj}.^3.*gate.INah{jj};
    mhim = [0 mhi(1:end-1)];
    mhip = [mhi(2:end) 0];

    ni = gate.IK{jj}; 
    nim = [0 ni(1:end-1)];
    nip = [ni(2:end) 0];
    
    zi = gate.IL{jj};
    zim = [0 zi(1:end-1)];
    zip = [zi(2:end) 0];
    
    abi = gate.IAa{jj}.^3.*gate.IAb{jj}; 
    abim = [0 abi(1:end-1)];
    abip = [abi(2:end) 0];
    
    GHi = [p_conds.IH.G{jj} 0];
    GHim = [0 GHi(1:end-1)];
    
    GKi = [p_conds.IK.G{jj} 0];
    GKim = [0 GKi(1:end-1)];
    
    GNai = [p_conds.INa.G{jj} 0];
    GNaim = [0 GNai(1:end-1)];
    
    GLi = [p_conds.IL.G{jj} 0];
    GLim = [0 GLi(1:end-1)];
    
    GAi = [p_conds.IA.G{jj} 0];
    GAim = [0 GAi(1:end-1)];
    
    % Diagonal elements
     
    % H-current matrix
    
    IH_lhs1 = 1/60*temp1.*(temp3.*ui.^2+temp4.*uim.^2);
    IH_lhs2 = 1/60*temp2.*(temp5.*ui.^2+temp6.*uip.^2);
                                       
    IH_lhscen{jj} = GHim.*[0 IH_lhs1(2:end)] + GHi.*[IH_lhs2(1:end-1) 0];
    
    % K-current matrix
    
    IK_lhs1 = 1/60*temp1.*(temp3.*ni.^4+temp4.*nim.^4);
    IK_lhs2 = 1/60*temp2.*(temp5.*ni.^4+temp6.*nip.^4);
                                       
    IK_lhscen{jj} = GKim.*[0 IK_lhs1(2:end)] + GKi.*[IK_lhs2(1:end-1) 0];
    
    % Na-current matrix
    
%     INa_lhs1 = 1/60*temp1.*(((10*ai+2*aim).*mi.^3+(2*ai+aim).*mim.^3).*hi+...
%                             ((2*ai+aim).*mi.^3+(ai+aim).*mim.^3).*him);
%     INa_lhs2 = 1/60*temp2.*(((10*ai+2*aip).*mi.^3+(2*ai+aip).*mip.^3).*hi+...
%                             ((2*ai+aip).*mi.^3+(ai+aip).*mip.^3).*hip);

    INa_lhs1 = 1/60*temp1.*(temp3.*mhi+temp4.*mhim);
    INa_lhs2 = 1/60*temp2.*(temp5.*mhi+temp6.*mhip);
                                       
    INa_lhscen{jj} = GNaim.*[0 INa_lhs1(2:end)] + GNai.*[INa_lhs2(1:end-1) 0];
    
    % L-current matrix
    
    IL_lhs1 = 1/60*temp1.*(temp3.*zi+temp4.*zim);
    IL_lhs2 = 1/60*temp2.*(temp5.*zi+temp6.*zip);
                                       
    IL_lhscen{jj} = GLim.*[0 IL_lhs1(2:end)] + GLi.*[IL_lhs2(1:end-1) 0];
    
    % A-current matrix
    
    IA_lhs1 = 1/60*temp1.*(temp3.*abi+temp4.*abim);
    IA_lhs2 = 1/60*temp2.*(temp5.*abi+temp6.*abip);
                                       
    IA_lhscen{jj} = GAim.*[0 IA_lhs1(2:end)] + GAi.*[IA_lhs2(1:end-1) 0];
    
    % right hand side vectors
    
    temp3 = (3*md.interp.radii{jj}+[0 md.interp.radii{jj}(1:end-1)]);
    temp4 = (md.interp.radii{jj}+[0 md.interp.radii{jj}(1:end-1)]);
    temp5 = (3*md.interp.radii{jj}+[md.interp.radii{jj}(2:end) 0]);
    temp6 = (md.interp.radii{jj}+[md.interp.radii{jj}(2:end) 0]);
    
    % H-current
    
    IH_rhs1 = 1/12*temp1.*(temp3.*ui.^2+temp4.*uim.^2);
    IH_rhs2 = 1/12*temp2.*(temp5.*ui.^2+temp6.*uip.^2);
    
    IH_rhscen{jj} = p_const.IH.v*(GHim.*[0 IH_rhs1(2:end)] + ...
                                  GHi.*[IH_rhs2(1:end-1) 0]);
                              
    % K-current
    
    IK_rhs1 = 1/12*temp1.*(temp3.*ni.^4+temp4.*nim.^4);
    IK_rhs2 = 1/12*temp2.*(temp5.*ni.^4+temp6.*nip.^4);
    
    IK_rhscen{jj} = p_const.IK.v*(GKim.*[0 IK_rhs1(2:end)] + ...
                                  GKi.*[IK_rhs2(1:end-1) 0]);
                              
    % Na-current
    
%     INa_rhs1 = 1/60*temp1.*(((12*ai+3*aim).*mi.^3+(3*ai+2*aim).*mim.^3).*hi+...
%                             (( 3*ai+2*aim).*mi.^3+(3*ai+2*aim).*mim.^3).*him);
%     INa_rhs2 = 1/60*temp2.*(((12*ai+3*aip).*mi.^3+(3*ai+2*aip).*mip.^3).*hi+...
%                             (( 3*ai+2*aip).*mi.^3+(3*ai+2*aip).*mip.^3).*hip);
                        
    INa_rhs1 = 1/12*temp1.*(temp3.*mhi+temp4.*mhim);
    INa_rhs2 = 1/12*temp2.*(temp5.*mhi+temp6.*mhip);

    INa_rhscen{jj} = p_const.INa.v*(GNaim.*[0 INa_rhs1(2:end)] + ...
                                    GNai.*[INa_rhs2(1:end-1) 0]);
                              
    % L-current
    
    IL_rhs1 = 1/12*temp1.*(temp3.*zi+temp4.*zim);
    IL_rhs2 = 1/12*temp2.*(temp5.*zi+temp6.*zip);
    
    IL_rhscen{jj} = p_const.IL.v*(GLim.*[0 IL_rhs1(2:end)] + ...
                                  GLi.*[IL_rhs2(1:end-1) 0]);
                              
    % A-current
    
    IA_rhs1 = 1/12*temp1.*(temp3.*abi+temp4.*abim);
    IA_rhs2 = 1/12*temp2.*(temp5.*abi+temp6.*abip);
                        
    IA_rhscen{jj} = p_const.IA.v*(GAim.*[0 IA_rhs1(2:end)] + ...
                                  GAi.*[IA_rhs2(1:end-1) 0]);                              
                                           
%     aip = ai(2:end);
%     ai = ai(1:end-1);
    
    temp1 = sqrt(h^2+(md.interp.radii{jj}(2:end)-md.interp.radii{jj}(1:end-1)).^2);
    temp2 = (3*md.interp.radii{jj}(1:end-1)+2*md.interp.radii{jj}(2:end));
    temp3 = (2*md.interp.radii{jj}(1:end-1)+3*md.interp.radii{jj}(2:end));
    
    uip = ui(2:end);
    ui = ui(1:end-1);
    
%     mip = mi(2:end);
%     mi = mi(1:end-1);
%     
%     hip = hi(2:end);
%     hi = hi(1:end-1);

    mhip = mhi(2:end);
    mhi = mhi(1:end-1);
    
    nip = ni(2:end);
    ni = ni(1:end-1);
    
    zip = zi(2:end);
    zi = zi(1:end-1);
    
    abip = abi(2:end);
    abi = abi(1:end-1);
    
    GHi = GHi(1:end-1);
    GKi = GKi(1:end-1);
    GNai = GNai(1:end-1);    
    GLi = GLi(1:end-1);
    GAi = GAi(1:end-1); 
    
    % off diagonal elements
    
    % H-current matrix
    
    IH_lhsoff{jj} = GHi/60.*temp1.*(ui.^2.*temp2+uip.^2.*temp3);
                                                
    % K-current matrix
    
    IK_lhsoff{jj} = GKi/60.*temp1.*(ni.^4.*temp2+nip.^4.*temp3); 
                                                
    % Na-current matrix
    
%     INa_lhsoff{jj} = GNai/60.*sqrt(h^2+(aip-ai).^2).*...
%                      (((2*ai+aip).*mi.^3+(ai+aip).*mip.^3).*hi+...
%                       ((ai+aip).*mi.^3+(ai+2*aip).*mip.^3).*hip);

    INa_lhsoff{jj} = GNai/60.*temp1.*(mhi.*temp2+mhip.*temp3); 
                  
    % L-current matrix
    
    IL_lhsoff{jj} = GLi/60.*temp1.*(zi.*temp2+zip.*temp3);
    
    % A-current matrix
    
    IA_lhsoff{jj} = GAi/60.*temp1.*(abi.*temp2+abip.*temp3);
    
end

[IH_lhs,IH_rhs] = assemble(IH_lhscen,IH_lhsoff,IH_rhscen,gate.IH,2,gate.null,nc,md,...
                           p_conds.IH.GS,p_const.IH.v,p_const);
                       
[IK_lhs,IK_rhs] = assemble(IK_lhscen,IK_lhsoff,IK_rhscen,gate.IK,4,gate.null,nc,md,...
                           p_conds.IK.GS,p_const.IK.v,p_const);  
                       
[INa_lhs,INa_rhs] = assemble(INa_lhscen,INa_lhsoff,INa_rhscen,...
                           gate.INam,3,gate.INah,nc,md,p_conds.INa.GS,...
                           p_const.INa.v,p_const);   
                       
[IL_lhs,IL_rhs] = assemble(IL_lhscen,IL_lhsoff,IL_rhscen,...
                           gate.IL,1,gate.null,nc,md,p_conds.IL.GS,...
                           p_const.IL.v,p_const);                          
                       
[IA_lhs,IA_rhs] = assemble(IA_lhscen,IA_lhsoff,IA_rhscen,...
                          gate.IAa,3,gate.IAb,nc,md,p_conds.IA.GS,...
                          p_const.IA.v,p_const);                             

function [lhs,rhs] = assemble(lhscen,lhsoff,rhscen,cgate1,cp1,cgate2,...
                              nc,md,GS,v,p_const)

lhs = spalloc(md.count.L,md.count.L,md.count.L*3-4);
rhs = zeros(md.count.L,1);

% first root is designated as 'master root'

jj = md.rootdex(end);

segh = md.segh(jj);
segt = md.segt(jj);

st = md.count.L*(segh-1)+segh;
fin = md.count.L*(segt-1)+segt;
step = md.count.L+1;

lhs(st:step:fin) = lhscen{jj};
lhs(st+1:step:fin-md.count.L) = lhsoff{jj};
lhs(st+md.count.L:step:fin-1) = lhsoff{jj};

rhs(segh:segt) = rhscen{jj};

% rest of the roots

for ii = 1:length(md.rootdex)-1

    jj = md.rootdex(ii);
    
    segh = md.segh(jj);
    segt = md.segt(jj);
    
    st = md.count.L*(segh-1)+segh;
    fin = md.count.L*(segt-1)+segt;
    step = md.count.L+1;
    
    lhs(st:step:fin) = lhscen{jj}(1:end-1);
    lhs(st+1:step:fin-md.count.L) = lhsoff{jj}(1:end-1);
    lhs(st+md.count.L:step:fin-1) = lhsoff{jj}(1:end-1);
    
    rhs(segh:segt) = rhscen{jj}(1:end-1);
    
    lhs(end,end) = lhs(end,end) + lhscen{jj}(end);
    lhs(end,segt) = lhsoff{jj}(end);
    lhs(segt,end) = lhsoff{jj}(end);
    
    rhs(end) = rhs(end) + rhscen{jj}(end);
    
end

% rest of the branches

for ii = 1:length(md.notrootdex)
   
    jj = md.notrootdex(ii);
    
    segh = md.segh(jj);
    segt = md.segt(jj);
    
    st = md.count.L*(segh-1)+segh;
    fin = md.count.L*(segt-1)+segt;
    step = md.count.L+1;
      
    lhs(st:step:fin) = lhscen{jj}(1:end-1);
    lhs(st+1:step:fin-md.count.L) = lhsoff{jj}(1:end-1);
    lhs(st+md.count.L:step:fin-1) = lhsoff{jj}(1:end-1);
    
    rhs(segh:segt) = rhscen{jj}(1:end-1);
    
end

% connections

for ii = 1:length(md.par)
   
    jj = md.par(ii);
    
    segh = md.segh(jj);
    d1 = nc.treedata{jj}(1);
    d2 = nc.treedata{jj}(2);
    
    segt1 = md.segt(d1);
    segt2 = md.segt(d2);
    
    lhs(segh,segh) = lhs(segh,segh) + ...
                       lhscen{d1}(end) + lhscen{d2}(end); 
    lhs(segh,segt1) = lhsoff{d1}(end);
    lhs(segt1,segh) = lhsoff{d1}(end);
    lhs(segh,segt2) = lhsoff{d2}(end);
    lhs(segt2,segh) = lhsoff{d2}(end);
    
    rhs(segh) = rhs(segh) + rhscen{d1}(end) + rhscen{d2}(end);
    
end

%lhs(end,end) = lhs(end,end) + p_const.soma.As*GS*cgate1{end}(end)^cp1*cgate2{end}(end);

%rhs(end) = rhs(end) + p_const.soma.As*GS*v*cgate1{end}(end)^cp1*cgate2{end}(end);

% function [segh, segt, root] = neur_headtailh(nc,md)
% 
% segt = zeros(md.count.N,1);
% segh = zeros(md.count.N,1);
% root = zeros(md.count.N,1);
% 
% segh(1) = 1;
% 
% % tempsize(1) = md.interp.size(1);
% % segt(1) = tempsize(1);
% % segh(2) = segt(1)+1;
% 
% % root(1) = 1;
% 
% for ii = 1:md.count.N-1
% 
%     % make tempsize array (adjust for triple-click)
%     
%     tempsize(ii) = md.interp.size(ii)-1;
%     fr = nc.roots(find(nc.roots == ii));
%     %tempsize(fr) = tempsize(fr) + 1;
%     
%     segt(ii) = sum(tempsize(1:ii));  
%     segh(ii+1) = segt(ii)+1;
%     
%     root(fr) = 1;
%   
% end
% 
% tempsize(md.count.N) = md.interp.size(md.count.N);
% segt(md.count.N) = sum(tempsize(1:md.count.N));
% 
% root(md.count.N) = 1;
% 
% %segh(end) = [];