function [out] = neur_solverh_act(M,K,L,b,nc,md,p_const,p_conds,...
    simd,filename)

%WRITEF1 = fopen([filename '.n1'],'w');
%WRITEF2 = fopen([filename '.n2'],'w');
%WRITEF3 = fopen([filename '.n3'],'w');

%fwrite(WRITEF3,md.count.L,'double');
%fwrite(WRITEF3,md.count.N,'double');
%fwrite(WRITEF3,md.segh,'double');
%fwrite(WRITEF3,md.segt,'double');

%fwrite(WRITEF2,simd.t,'double');

N = md.count.L;
Nt = length(simd.dt);

io = neur_stimulus(md,simd);
eo = zeros(N,1);

% current pulse at the SOMA
eo(end) = 1;

% rough guess for initial value for v
v = -60*ones(N,1);
% initial value for Ca CaB CaE
y = zeros(N*3,1);

% solve for initial v
LHSpas = M+simd.dt*(L+K);
options = optimset('display','iter','TolFun',1e-15);
vinit = fsolve(@vinitial,v,options,K,L,b,nc,md,p_const,p_conds,io,eo,simd);

j = 2;
%t(1) = 0;

%out.z = zeros(N,length(simd.t));
v = vinit;
%v(20:40) = 0;
%fwrite(WRITEF1,v,'double');

% initial gating values
[gate,vdex] = gateeval(v,nc,md);
out.v = cell(md.count.N,1);
out.Ca = cell(md.count.N,1);
out.CaB = cell(md.count.N,1);
out.CaE = cell(md.count.N,1);
out.INa = cell(md.count.N,1);
out.IK = cell(md.count.N,1);
out.IA = cell(md.count.N,1);
out.IL = cell(md.count.N,1);
out = outputupdate(out,v,y,gate,vdex,nc,md,p_conds,p_const,1);

%[IH_lhs,IH_rhs] = neur_assemble2(nc,md,p_const,p_conds,gate);

[Ca_M,Ca_LHS] = neur_assembleCaLHS(nc,md,p_const,p_conds);
[Ca_L,Ca_U] = lu(Ca_M+simd.dt*Ca_LHS);

jfinal = simd.T/simd.dt;
jtenper = jfinal/10;

out.t = simd.t;
%out.z(:,1) = gate.IL{end};

while (j-1)*simd.dt <= simd.T

    %t(j) = (j-1)*simd.dt;

    % gating variables
    gate = gateupdate(v,gate,vdex,nc,md,simd);

    [IH_lhs,IH_rhs,IK_lhs,IK_rhs,INa_lhs,INa_rhs,IL_lhs,IL_rhs,IA_lhs,IA_rhs] = ...
        neur_assemble2(nc,md,p_const,p_conds,gate);

    RHS = M*v+simd.dt*(b+IH_rhs+INa_rhs+IK_rhs+IA_rhs+IL_rhs)+io(j)*eo*simd.dt;
    LHS = LHSpas + simd.dt*(IH_lhs+INa_lhs+IK_lhs+IA_lhs+IL_lhs);

    v = LHS \ RHS;
    out = outputupdate(out,v,y,gate,vdex,nc,md,p_conds,p_const,j);
    %out.pots(:,j) = v;
    %fwrite(WRITEF1,v,'double');
    
    cy = processCa(y,vdex,md);
    [Ca_RHS] = neur_assembleCaRHS(nc,md,p_const,p_conds,cy,out.IL);
    Ca_RHS = Ca_RHS*simd.dt+Ca_M*y;
    
    y = Ca_U \ (Ca_L \ Ca_RHS);
    
    j = j + 1;

    if mod(j,jtenper) == 0

        disp([num2str(j/jtenper*10) ' % done'])

    end

end

out.t = simd.t;
for ii = 1:md.count.N
    out.x{ii} = md.grid.x{ii}(end:-1:1);
end
% for jj = 1:md.count.N-1
%     out.vdex{jj} = [vdex{jj}(3):vdex{jj}(2) vdex{jj}(1)] ; 
% end
% out.vdex{md.count.N} = vdex{md.count.N}(2):vdex{md.count.N}(1); 

function val = vinitial(v,K,L,b,nc,md,p_const,p_conds,io,eo,simd)

gate = gateeval(v,nc,md);

[IH_lhs,IH_rhs,IK_lhs,IK_rhs,INa_lhs,INa_rhs,IL_lhs,IL_rhs,IA_lhs,IA_rhs] = ...
        neur_assemble2(nc,md,p_const,p_conds,gate);

val = (K+L+IH_lhs+INa_lhs+IK_lhs+IA_lhs+IL_lhs)*v-b-IH_rhs-INa_rhs-IK_rhs-IA_rhs-IL_rhs-io(1)*eo*simd.dt;

function gate = gateupdate(v,gate,vdex,nc,md,simd)

for ii = 1:md.count.N-1
    %vdex = processpot(nc,md,ii);
    vdat = v([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)])';
    gate.IH{ii} = (simd.dt*IHuinf(vdat)+IHutau(vdat).*gate.IH{ii})./...
                  (IHutau(vdat)+simd.dt);
    gate.IK{ii} = (gate.IK{ii}+simd.dt.*an(vdat))./...
                  (1+simd.dt*(an(vdat)+bn(vdat)));
    gate.INam{ii} = (gate.INam{ii}+simd.dt.*am(vdat))./...
                    (1+simd.dt*(am(vdat)+bm(vdat)));
    gate.INah{ii} = (gate.INah{ii}+simd.dt.*ah(vdat))./...
                    (1+simd.dt*(ah(vdat)+bh(vdat)));    
    gate.IL{ii} = (simd.dt*ILzinf(vdat)+ILztau(vdat).*gate.IL{ii})./...
                  (ILztau(vdat)+simd.dt);
    gate.IAa{ii} = (simd.dt*IAainf(vdat)+IAatau(vdat).*gate.IAa{ii})./...
                   (IAatau(vdat)+simd.dt);
    gate.IAb{ii} = (simd.dt*IAbinf(vdat)+IAbtau(vdat).*gate.IAb{ii})./...
                   (IAbtau(vdat)+simd.dt);
end
%vdex = processpot(nc,md,md.count.N);
vdat = v(vdex{md.count.N}(2):vdex{md.count.N}(1))';
gate.IH{md.count.N} = (simd.dt*IHuinf(vdat)+IHutau(vdat).*...
                      gate.IH{md.count.N})./(IHutau(vdat)+simd.dt);
gate.IK{md.count.N} = (gate.IK{md.count.N}+simd.dt.*an(vdat))./...
                      (1+simd.dt*(an(vdat)+bn(vdat)));
gate.INam{md.count.N} = (gate.INam{md.count.N}+simd.dt.*am(vdat))./...
                        (1+simd.dt*(am(vdat)+bm(vdat)));
gate.INah{md.count.N} = (gate.INah{md.count.N}+simd.dt.*ah(vdat))./...
                        (1+simd.dt*(ah(vdat)+bh(vdat)));   
gate.IL{md.count.N} = (simd.dt*ILzinf(vdat)+ILztau(vdat).*...
                      gate.IL{md.count.N})./(ILztau(vdat)+simd.dt);                    
gate.IAa{md.count.N} = (simd.dt*IAainf(vdat)+IAatau(vdat).*gate.IAa{md.count.N})./...
                      (IAatau(vdat)+simd.dt);
gate.IAb{md.count.N} = (simd.dt*IAbinf(vdat)+IAbtau(vdat).*gate.IAb{md.count.N})./...
                      (IAbtau(vdat)+simd.dt);

function [gate,vdex] = gateeval(v,nc,md)

for ii = 1:md.count.N-1
    vdex{ii} = processpot(nc,md,ii);
    gate.IH{ii} = IHuinf(v([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)])');
    gate.INam{ii} = INaminf(v([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)])');
    gate.INah{ii} = INahinf(v([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)])');
    gate.IK{ii} = IKninf(v([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)])');
    gate.IL{ii} = ILzinf(v([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)])');
    gate.IAa{ii} = IAainf(v([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)])');
    gate.IAb{ii} = IAbinf(v([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)])');
    gate.null{ii} = zeros(1,length(v([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)])'));
end
ii = md.count.N;
vdex{ii} = processpot(nc,md,ii);
gate.IH{md.count.N} = IHuinf(v(vdex{ii}(2):vdex{ii}(1))');
gate.INam{md.count.N} = INaminf(v(vdex{ii}(2):vdex{ii}(1))');
gate.INah{md.count.N} = INahinf(v(vdex{ii}(2):vdex{ii}(1))');
gate.IK{md.count.N} = IKninf(v(vdex{ii}(2):vdex{ii}(1))');
gate.IL{md.count.N} = ILzinf(v(vdex{ii}(2):vdex{ii}(1))');
gate.IAa{md.count.N} = IAainf(v(vdex{ii}(2):vdex{ii}(1))');
gate.IAb{md.count.N} = IAbinf(v(vdex{ii}(2):vdex{ii}(1))');
gate.null{md.count.N} = zeros(1,length(v(vdex{ii}(2):vdex{ii}(1))'));

function out = outputupdate(out,v,y,gate,vdex,nc,md,p_conds,p_const,j)

for ii = 1:md.count.N-1
    out.v{ii}(:,j) = v([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)]);
    out.Ca{ii}(:,j) = y([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)]);
    out.CaB{ii}(:,j) = y([(vdex{ii}(3)+md.count.L):(vdex{ii}(2)+md.count.L) vdex{ii}(1)+md.count.L]);
    out.CaE{ii}(:,j) = y([(vdex{ii}(3)+md.count.L*2):(vdex{ii}(2)+md.count.L*2) vdex{ii}(1)+md.count.L*2]);
    out.IL{ii}(:,j) = gate.IL{ii}.*...
                      [p_conds.IL.G{ii} p_conds.IL.G{md.parents(ii)}(1)].*...
                      (out.v{ii}(:,j)-p_const.IL.v)';
    out.INa{ii}(:,j) = gate.INam{ii}.^3.*gate.INah{ii}.*...
                       [p_conds.INa.G{ii} p_conds.INa.G{md.parents(ii)}(1)].*...
                       (out.v{ii}(:,j)-p_const.INa.v)';
    out.IK{ii}(:,j) =  gate.IK{ii}.^4.*...
                       [p_conds.IK.G{ii} p_conds.IK.G{md.parents(ii)}(1)].*...
                       (out.v{ii}(:,j)-p_const.IK.v)';
    out.IA{ii}(:,j) =  gate.IAa{ii}.^3.*gate.IAb{ii}.*...
                       [p_conds.IA.G{ii} p_conds.IA.G{md.parents(ii)}(1)].*...
                       (out.v{ii}(:,j)-p_const.IA.v)';
end
out.v{md.count.N}(:,j) = v(vdex{md.count.N}(2):vdex{md.count.N}(1));
out.Ca{md.count.N}(:,j) = y(vdex{md.count.N}(2):vdex{md.count.N}(1));
out.CaB{md.count.N}(:,j) = y(vdex{md.count.N}(2)+md.count.L:vdex{md.count.N}(1)+md.count.L);
out.CaE{md.count.N}(:,j) = y(vdex{md.count.N}(2)+md.count.L*2:vdex{md.count.N}(1)+md.count.L*2);
out.IL{md.count.N}(:,j) = gate.IL{md.count.N}.*p_conds.IL.G{end}(end).*...
                          (out.v{md.count.N}(:,j)'-p_const.IL.v);
out.INa{md.count.N}(:,j) = gate.INam{md.count.N}.^3.*gate.INah{md.count.N}.*...
                           p_conds.INa.G{end}(end).*(out.v{md.count.N}(:,j)'-p_const.INa.v);
out.IK{md.count.N}(:,j) = gate.IK{md.count.N}.^4.*...
                          p_conds.IK.G{end}(end).*(out.v{md.count.N}(:,j)'-p_const.IK.v);
out.IA{md.count.N}(:,j) = gate.IAa{md.count.N}.^3.*gate.IAb{md.count.N}.*...
                          p_conds.IA.G{end}(end).*(out.v{md.count.N}(:,j)'-p_const.IA.v);

function cy = processCa(y,vdex,md)

Ca = y(1:md.count.L);
CaB = y(md.count.L+1:2*md.count.L);
CaE = y(2*md.count.L+1:3*md.count.L);

for ii = 1:md.count.N-1
    cy.Ca{ii} = Ca([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)]);
    cy.CaB{ii} = CaB([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)]);
    cy.CaE{ii} = CaE([vdex{ii}(3):vdex{ii}(2) vdex{ii}(1)]);    
end
cy.Ca{md.count.N} = Ca(vdex{md.count.N}(2):vdex{md.count.N}(1));
cy.CaB{md.count.N} = CaB(vdex{md.count.N}(2):vdex{md.count.N}(1));
cy.CaE{md.count.N} = CaE(vdex{md.count.N}(2):vdex{md.count.N}(1));

function vdex = processpot(nc,md,dendnum)

if dendnum == nc.roots(end)

    vdex = [md.segt(dendnum) md.segh(dendnum)];
    %vdat = v(vdex(2):vdex(1))';

elseif find(nc.roots == dendnum)

    vdex = [md.count.L md.segt(dendnum) md.segh(dendnum)];
    %vdat = v([vdex(3):vdex(2) vdex(1)])';

else

    pardex = md.parents(dendnum);
    vdex = [md.segh(pardex) md.segt(dendnum) md.segh(dendnum)] ;
    %vdat = v([vdex(3):vdex(2) vdex(1)])';

end

function io = neur_stimulus(md,simd)

if simd.Is.end > simd.T
    simd.Is.end = simd.T;
end

io = zeros(length(simd.t),1);

startindex = simd.Is.start/simd.dt+1;
endindex = simd.Is.end/simd.dt+1;

io(startindex:endindex) = simd.Is.mag*1/(2*pi);

%io = simd.Is.mag*max(simd.t,0).*exp(-max(simd.t,0)/2);
%io(endindex:end) = 0;
%io = io/(2*pi);

function val = IHuinf(v)

val = 1./(1+exp((v+69)/7.1));

function val = IHutau(v)

val = 10./(exp((v+66.4)/9.3)+exp(-(v+81.6)/13));

function val = an(v)
val = .02*(v+45.7)./(1-exp(-(v+45.7)/10));

function val = bn(v)
val = .25*exp(-0.0125*(v+55.7));

function val = am(v)
val = 0.38*(v+29.7)./(1-exp(-(v+29.7)/10));

function val = bm(v)
val = 15.2*exp(-0.0556*(v+54.7));

function val = ah(v)
val = 0.266*exp(-0.05*(v+48));

function val = bh(v)
val = 3.8./(1+exp(-(v+18)/10));

function val = INaminf(v)
val = am(v)./(am(v)+bm(v));
function val = INahinf(v)
val = ah(v)./(ah(v)+bh(v));
function val = IKninf(v)
val = an(v)./(an(v)+bn(v));

function val = ILzinf(v)
val = (1+tanh((v+1)/15))/2;

function val = ILztau(v)
val = 0.01;

function val = IAainf(v)
val = 0.0761*exp(0.0314*(v+94.22))./(1+exp(0.0346*(v+1.17)));
val = val.^(1/3);

function val = IAatau(v)
val = 0.3632+1.158./(1+exp(0.0497*(v+55.96)));

function val = IAbinf(v)
val = 1./(1+exp(0.0688*(v+53.3)));
val = val.^4;

function val = IAbtau(v)
val = 1.24+2.678./(1+exp(0.0624*(v+50)));

