close all
clear

N= 50;
dt = 0.05;
T = 10;

disp('exact solution...')

%vex = paxon_ex(50,.05,10,4);
load vex

disp('done')

% read in data

filename = 'test.asc'

nc = neur_converterh(filename);

% simulation time

simd.dt = .1;   % ms
simd.T = T;    % ms

simd.Is.start = 0;  % ms
simd.Is.end = T;   % ms

% current pulse

simd.Is.mag = 1;  % uA
%simd.Is.mag = 0;  % nA

simd.t = 0:simd.dt:simd.T;

% construct morphology

md = neur_loadmorph_direct(nc,[N],1)

% parameters

p_const = neur_param_const(nc);
p_conds = neur_param_conds(nc,md);

% M K L

[M, K, L, b, md] = neur_assembleMKh(nc,md,p_const,p_conds);

save ncmd nc md

% Hines solver

disp('M,K,L ready')

disp('Solving system...')

% solve for v

tic
[v,t] = neur_solverh(M,K,L,b,md,p_const,p_conds,simd,filename);
toc

fprintf('\n')
out = neur_read('test.asc')
out.v = out.v(end:-1:1,:)-p_const.pas.v;


surf(vex)
figure
surf(out.v)

maxerr = max(max(out.v-vex))